<?php

namespace App\Action\Bitbucket;

use App\Utility\Error;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;

class BitbucketBuildCommentCheck
{
   /**
    * @var array
    */
   private $comments;

   public function __construct(array $comments) {
      $this->comments = $comments;
   }

   public function __invoke(ServerRequestInterface $request,
                            ResponseInterface $response,
                            callable $next) {
      $serverParams = $request->getServerParams();
      if (($serverParams['HTTP_X_EVENT_KEY'] ?? null)
           == "pullrequest:comment_created") {
         $body = $request->getParsedBody();
         $comment = strtolower(
            trim($body['comment']['content']['raw'])
         );
         if (!in_array($comment, $this->comments)) {
            $error = new Error(
               "Not building PR just because you commented.",
               ['log' => false]);
         }
      }

      return $next($request, $response, $error ?? null);
   }
}