<?php

namespace App\Service\Rabbit;

use PhpAmqpLib\Connection\AMQPStreamConnection;
use PhpAmqpLib\Message\AMQPMessage;
use Psr\Http\Message\ServerRequestInterface;
use Zend\Diactoros\Response\JsonResponse;

class QueueRequestService
{
   /**
    * @var AMQPStreamConnection
    */
   private $connection;

   public function __construct(
      AMQPStreamConnection $connection
   ) {
      $this->connection = $connection;
   }

   /**
    * @return JsonResponse
    */
   public function queueRequest(
      ServerRequestInterface $request
   ) {
      $channel = $this->connection->channel();
      $channel->queue_declare('process_requests', false,
                              true, false, false);

      $data = json_encode(['request' => serialize($request)]);
      $msg  = new AMQPMessage(
         $data, ['delivery_mode'
                  => AMQPMessage::DELIVERY_MODE_PERSISTENT]);

      $channel->basic_publish($msg, '', 'process_requests');

      $channel->close();
      $this->connection->close();

      // send response to client
      return new JsonResponse("Processing...");
   }
}