<?php

namespace App\Action\Deploy\Validators;

use App\Utility\Error;
use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface;

class ValidateKey
{
   private $keys;

   public function __construct(array $keys) {
      $this->keys = $keys;
   }

   public function __invoke(ServerRequestInterface $request,
                            ResponseInterface $response,
                            callable $next) {
      $params = $request->getQueryParams();
      $path = $request->getUri()->getPath();
      $keys = $this->keys[$path] ?? [];
      if (!in_array(($params['key'] ?? null), $keys)) {
         $error = new Error("Invalid request key.");
      }

      return $next($request, $response, $error ?? null);
   }
}