<?php
$user = new \stdClass();
$user->role = 'normal_user';

$roles = [
   'normal_user' => ['user-read'],
   'admin_user' => [
      'user-read', 'user-delete', 'user-update'
   ]
];

function hasRole($user, $roleName) {
   return ($user->role == $roleName);
}

function has($user, $permission, array $roles = []) {
   // See if it's a direct permission first
   if (isset($user->permissions)
      && in_array($permission, $user->permissions)) {
      return true;
   }

   // Now see if it's one of the ones in our grouping
   $userRole = $user->role;
   $permissions = $roles[$userRole];
   if (in_array($permission, $permissions) == true) {
      return true;
   }

   // No matching, return a failure - safety first!
   return false;
}

if (hasRole($user, 'normal_user') === true) {
   echo 'Good to go!';

   if (has($user, 'user-read', $roles) === true) {
      echo 'We can read users too!';
   }
}